From 091dca8d029c3927dad46003f958dc1726cb439d Mon Sep 17 00:00:00 2001
From: Philip Cali <philip.cali@gmail.com>
Date: Wed, 15 Feb 2012 09:35:12 -0600
Subject: Add tab index support on table format

---
 grade/report/quick_edit/classes/lib.php   |   22 ++++++++++--
 grade/report/quick_edit/classes/uilib.php |   52 ++++++++++++++++++++++++-----
 2 files changed, 61 insertions(+), 13 deletions(-)

diff --git a/grade/report/quick_edit/classes/lib.php b/grade/report/quick_edit/classes/lib.php
index c5f0d9b..6b62600 100644
--- a/grade/report/quick_edit/classes/lib.php
+++ b/grade/report/quick_edit/classes/lib.php
@@ -184,16 +184,23 @@ abstract class quick_edit_screen {
     }
 }
 
-abstract class quick_edit_tablelike extends quick_edit_screen {
+abstract class quick_edit_tablelike extends quick_edit_screen implements tabbable {
     var $items;
 
     public abstract function headers();
 
     public abstract function format_line($item);
 
+    public function get_tabindex() {
+        return (count($this->definition()) * $this->total) + $this->index;
+    }
+
     public function format_definition($line, $grade) {
-        foreach ($this->definition() as $field) {
-            $html = $this->factory()->create($field)->format($grade);
+        foreach ($this->definition() as $i => $field) {
+            // Table tab index
+            $tab = ($i * $this->total) + $this->index;
+
+            $html = $this->factory()->create($field)->format($grade, $tab);
 
             if ($field == 'finalgrade') {
                 $html .= $this->structure->get_grade_analysis_icon($grade);
@@ -212,7 +219,12 @@ abstract class quick_edit_tablelike extends quick_edit_screen {
 
         $table->data = array();
 
+        // To be used for extra formatting
+        $this->index = 0;
+        $this->total = count($this->items);
+
         foreach ($this->items as $item) {
+            $this->index ++;
             $table->data[] = $this->format_line($item);
         }
 
@@ -229,7 +241,9 @@ abstract class quick_edit_tablelike extends quick_edit_screen {
 
     public function buttons() {
         $save = html_writer::empty_tag('input', array(
-            'type' => 'submit', 'value' => get_string('update')
+            'type' => 'submit',
+            'value' => get_string('update'),
+            'tabindex' => $this->get_tabindex()
         ));
 
         return array($save);
diff --git a/grade/report/quick_edit/classes/uilib.php b/grade/report/quick_edit/classes/uilib.php
index 8dd1cb4..e64b148 100644
--- a/grade/report/quick_edit/classes/uilib.php
+++ b/grade/report/quick_edit/classes/uilib.php
@@ -19,8 +19,11 @@ class quick_edit_factory_class_wrap {
         $this->class = $class;
     }
 
-    function format($what) {
-        return new $this->class($what);
+    function format() {
+        $args = func_get_args();
+
+        $reflect = new ReflectionClass($this->class);
+        return $reflect->newInstanceArgs($args);
     }
 }
 
@@ -64,9 +67,11 @@ class quick_edit_empty_element extends quick_edit_ui_element {
 
 class quick_edit_text_attribute extends quick_edit_ui_element {
     var $is_disabled;
+    var $tabindex;
 
-    function __construct($name, $value, $is_disabled = false) {
+    function __construct($name, $value, $is_disabled = false, $tabindex = null) {
         $this->is_disabled = $is_disabled;
+        $this->tabindex = $tabindex;
         parent::__construct($name, $value);
     }
 
@@ -81,6 +86,10 @@ class quick_edit_text_attribute extends quick_edit_ui_element {
             'value' => $this->value
         );
 
+        if (!empty($this->tabindex)) {
+            $attributes['tabindex'] = $this->tabindex;
+        }
+
         if ($this->is_disabled) {
             $attributes['disabled'] = 'DISABLED';
         }
@@ -100,9 +109,11 @@ class quick_edit_text_attribute extends quick_edit_ui_element {
 
 class quick_edit_checkbox_attribute extends quick_edit_ui_element {
     var $is_checked;
+    var $tabindex;
 
-    function __construct($name, $is_checked = false) {
+    function __construct($name, $is_checked = false, $tabindex = null) {
         $this->is_checked = $is_checked;
+        $this->tabindex = $tabindex;
         parent::__construct($name, 1);
     }
 
@@ -128,6 +139,10 @@ class quick_edit_checkbox_attribute extends quick_edit_ui_element {
             'name' => 'old' . $this->name
         );
 
+        if (!empty($this->tabindex)) {
+            $attributes['tabindex'] = $this->tabindex;
+        }
+
         if ($this->is_checked) {
             $attributes['checked'] = 'CHECKED';
             $hidden['value'] = 1;
@@ -149,17 +164,30 @@ abstract class quick_edit_attribute_format {
     }
 }
 
-abstract class quick_edit_grade_attribute_format extends quick_edit_attribute_format implements unique_name {
+abstract class quick_edit_grade_attribute_format extends quick_edit_attribute_format implements unique_name, tabbable {
     var $name;
 
-    function __construct($grade) {
-        $this->grade = $grade;
+    function __construct() {
+        $args = func_get_args();
+
+        $this->get_arg_or_nothing($args, 0, 'grade');
+        $this->get_arg_or_nothing($args, 1, 'tabindex');
     }
 
     function get_name() {
         return "{$this->name}_{$this->grade->itemid}_{$this->grade->userid}";
     }
 
+    function get_tabindex() {
+        return isset($this->tabindex) ? $this->tabindex : null;
+    }
+
+    private function get_arg_or_nothing($args, $index, $field) {
+        if (isset($args[$index])) {
+            $this->$field = $args[$index];
+        }
+    }
+
     public abstract function set($value);
 }
 
@@ -179,6 +207,10 @@ interface be_checked {
     function is_checked();
 }
 
+interface tabbable {
+    function get_tabindex();
+}
+
 class quick_edit_finalgrade_ui extends quick_edit_grade_attribute_format implements unique_value, be_disabled {
 
     var $name = 'finalgrade';
@@ -200,7 +232,8 @@ class quick_edit_finalgrade_ui extends quick_edit_grade_attribute_format impleme
         return new quick_edit_text_attribute(
             $this->get_name(),
             $this->get_value(),
-            $this->is_disabled()
+            $this->is_disabled(),
+            $this->get_tabindex()
         );
     }
 
@@ -269,7 +302,8 @@ class quick_edit_feedback_ui extends quick_edit_grade_attribute_format implement
         return new quick_edit_text_attribute(
             $this->get_name(),
             $this->get_value(),
-            $this->is_disabled()
+            $this->is_disabled(),
+            $this->get_tabindex()
         );
     }
 
-- 
1.7.1


